import sys, json
from pyrois_common import message_profile

def gen_client_info(id,port):
    tab_mod_name = {
        'SystemInformation': 'System_Information',
        'PersonLocalization': 'Person_Localization',
        'FaceLocalization': 'Face_Localization',
        'SoundLocalization': 'Sound_Localization',
        'SpeechRecognition': 'Speech_Recognition',
        'GestureRecognition': 'Gesture_Recognition',
        'SpeechSynthesis': 'Speech_Synthesis',
        'Reaction': 'Reaction',
        'Navigation': 'Navigation',
        'Follow': 'Follow',
        'Move': 'Move'
    }
    token = id.split(':')
    if token[3] == 'HRIComponent':
        if token[6] in tab_mod_name.keys():
            comp = token[6]
            mod_name = f"{tab_mod_name[comp]}_client"
            IF_name = f"{tab_mod_name[comp]}_Client"
        else:
            print('unknown component', token[6])
            sys.exit(1)
    elif token[3] == 'HRIEngine':
        mod_name = 'HRI_Engine_client_sample'
        IF_name = 'IF'

    d = {
        "module": f"pyrois_common.{mod_name}",
        "class": IF_name,
        "url":f"http://127.0.0.1:{port}"
    }
    return d

def main():
    r=message_profile.Analyze_Engine_Profile('ep1')
    x=r.analysis()
    # print(x[0])
    c=0
    d={}
    for k, v in x[1].items():
        if c == 0:
            c=1
        else:
            d[k] = gen_client_info(k,8000+c)
            c+=1
        for y in v:
            d[y] = gen_client_info(y,8000+c)
            c+=1

        # print(k,v)
    # for y in x[2]:
    #     print(y)
    print(json.dumps(d))



main()
